<TeXmacs|0.3.4.3>

<style|article>

<\body>
  <assign|answer|<macro|body|<surround|<vspace*|0.5fn><format|no first
  indentation>|<vspace|0.5fn><format|no indentation after>|<with|font
  shape|slanted|<arg|body>>>>><assign|code|<macro|body|<surround|<vspace*|1fn\
  >|<vspace|1fn><format|no indentation after>|<with|font
  family|tt|language|verbatim|<arg|body>>>>><apply|title|Comments on
  Mathemagix><apply|author|Daniel Grayson & Joris van der
  Hoeven><apply|address|Laboratoire de Mathmatiques (bt. 425)<format|next
  line>Universit Paris-Sud<format|next line>91405 Orsay Cedex<format|next
  line>France>

  <apply|maketitle>

  <\abstract>
    In this paper we discuss some comments by D. Grayson on Mathemagix.
  </abstract>

  <section|First comments by D. Grayson>

  <\enumerate>
    <item>What is so magical about ``mathemagix''?

    <\answer>
      Mathemagix puts a spell on your source code and transforms it into the
      best binaries you have ever seen.
    </answer>

    <item>Syntax is hard to parse:

    <\code>
      x,y:int
    </code>

    seems to mean

    <\code>
      x:int,y:int
    </code>

    but if so, then which operator has higher parsing precedence?

    <\answer>
      The <with|font shape|right|font family|tt|,> has a higher precedence.
      We might also consider writing <with|font shape|right|font
      family|tt|(x,y):Int> instead.
    </answer>

    <item>This syntax is confusing because I can't deduce what individual
    meanings <with|font family|tt|:> and <with|font family|tt|with> have.

    <\code>
      Point : with { x : Int; }
    </code>

    It's hard to think of

    <\code>
      with { x : Int; }
    </code>

    standing on its own as a type because <with|font family|tt|with> is an
    English preposition. In C++ one uses <with|font family|tt|struct> or
    <with|font family|tt|class>, which is a noun, and seems more natural.

    <\answer>
      <surround|The <with|font family|tt|font shape|right|with> keyword has
      the advantage that several <with|font family|tt|font
      shape|right|with>'s may be combined with different modifiers:|In order
      to increase the readability we might consider the creation of a class
      <with|font family|tt|font shape|right|Class> with no exports, from
      which any other class should inherit:|<\with>
        font shape
      <|with>
        right
      <|with>
        \;

        <\code>
          My_Type : $Ring

          with intern { ... }

          with extern { ... }
        </code>

        \;
      </with>>

      <\with>
        font shape
      <|with>
        right
      <|with>
        <\code>
          Point : $Class

          with { x: Int; }
        </code>
      </with>

      One might also use <with|font family|tt|font shape|right|Void> instead
      of <with|font family|tt|font shape|right|Class>.
    </answer>

    <item>Why must we use <with|font family|tt|$> here?

    <\code>
      A : $B with { x : Int; }
    </code>

    <\answer>
      <surround|<with|font family|tt|font shape|right|x:T> stands for
      ``<with|font family|tt|font shape|right|x> is of class <with|font
      family|tt|font shape|right|T>'', while <with|font family|tt|font
      shape|right|R:$Ring>, which is equivalent to|stands for ``<with|font
      family|tt|font shape|right|R> is a class, which inherits from
      <with|font family|tt|font shape|right|Ring>. I did not yet invent the
      optimal syntax for this kind of thing, one might also consider
      something like <with|font family|tt|font shape|right|R::Ring>. In any
      case, I would like to have a syntax which allows the user and the
      compiler to identify syntactically whether a declaration actually
      defines an instance of a certain class or a class of a certain
      signature. At this moment, the second kind of declarations always start
      with <with|font family|tt|font family|tt|font shape|right|:$>.|<\with>
        font shape
      <|with>
        right
      <|with>
        \;

        <\code>
          R: $Class with { inherit Ring; }
        </code>

        \;
      </with>>
    </answer>

    <item>Comparing

    <\code>
      with { x : Int; }
    </code>

    and

    <\code>
      $B with { x : Int }
    </code>

    it seems that <with|font family|tt|with> is to be either a binary
    operator or a unary operator, depending on context. Why not say so? It
    may be too confusing, anyway.

    <\answer>
      The creation of the abstract class <with|font family|tt|font
      shape|right|Class> may help again at this point.
    </answer>

    <item>This looks too much like C:

    <\code>
      P: Point := [ 2, 3 ];
    </code>

    The <with|font family|tt|[ 2, 3 ]> doesn't have a meaning on its own. I
    like each subexpression to have a meaning. We could just as well ask for

    <\code>
      P: Point [ 2, 3 ];
    </code>

    and save some typing.

    <\answer>
      <surround|The expression <with|font family|tt|font shape|right|[2,3]>
      actually does have a meaning: it is a record of two integers. When
      defining <with|font family|tt|font shape|right|Point> (with only public
      intern exports), the compiler automatically generates|I do not like the
      second solution very much, because it would not always be clear whether
      <with|font family|tt|font shape|right|Point[2,3]> is a class or an
      initializer for an instance of some class. Moreover, new constructs
      should be added to the language to support such initializers. Finally,
      you do not always save typing:<\with>
        font shape
      <|with>
        right
      <|with>
        \;

        <\code>
          P: Point := [2,3];

          ...

          P := [4,5];
        </code>
      </with>|<\with>
        font shape
      <|with>
        right
      <|with>
        \;

        <\code>
          convert: Record(Int,Int) -\<gtr\> %
        </code>

        \;
      </with>>
    </answer>

    <item>You seem to allow declarations and definitions of functions to be
    separate, and also to allow expressions as initializers of static
    variables. This can be a problem in this code, where <with|font
    family|tt|x> gets used before getting initialized.

    <\code>
      Test : $Class with hello () -\<gtr\> ();

      x : Int := { hello(); 3; }

      Test == hello() : () == print \<less\>\<less\> x \<less\>\<less\> lf ;
    </code>

    It should be provable by the compiler that all variables are initialized
    before being used.

    <\answer>
      You are right that variables should be initialized before being used
      and therefore your sample code should be recognized to be incorrect by
      the compiler. I hope to detail soon the precise compiler strategy to
      perform this task (in the chapter about the implementation of the
      compiler).
    </answer>

    <item>In this code, why should you import <with|font family|tt|T>? It's
    declared right there.

    <\code>
      T ==\<gtr\> Record (x:Int, y:Int, z:Int == 10);

      import T;
    </code>

    <\answer>
      No it is not. First of all, the first line is just a macro definition.
      Secondly, even if <with|font family|tt|font shape|right|T> had been
      declared as a type, this would not have made its exports visible in the
      current scope. Although this rule may look a bit frustrating at a first
      sight, it is really a very clean one and has the huge advantage that no
      template-like mechanism is needed to compile parameterized types. In
      practice, I also believe that you will not need to use <with|font
      family|tt|font shape|right|import> much more in an average Mathemagix
      program, as <with|font family|tt|font shape|right|#include> in an
      average C/C++ program.
    </answer>

    <item>There is a lot of code like this. I'm wondering whether you have
    any way to create an instance of <with|font family|tt|T> without
    assigning it to a variable.

    <\code>
      a:T := [1,2];

      b:T := [y==8, 7, 9];

      c:T := [y==6, 5];
    </code>

    <\answer>
      You just got this impression from the examples given in the text. Of
      course functions may return values of type <with|font family|tt|font
      shape|right|T>, which can occur as auxiliairy values in other
      computations.
    </answer>

    <item><with|font family|tt|intern> exports and <with|font
    family|tt|extern> exports : I can't tell the difference between them,
    since there is no defintion. In 4.1 it sounds like the intern exports are
    data fields, and the extern exports are functions or methods, but that
    can't be right.

    <\answer>
      Intern exports act on an instance of class <with|font family|tt|font
      shape|right|%> using the <with|font family|tt|font
      shape|right|instance.field> syntax. Constant intern exports correspond
      to methods (like in C++) and variable intern exports to data fields.
      Extern exports are routines which are relevant to a class, but which do
      not act on instances of this class. Constant extern exports are like
      <with|font family|tt|font shape|right|friend> functions in C++.
      Variable extern exports correspond to variables relative to the class
      (although I do not yet have a precise semantics for the variable extern
      exports).
    </answer>

    <item>Functions can be declared either like square:

    <\code>
      Int-\<gtr\>Int == (n:Int) :-\<gtr\> n*n;
    </code>

    or in the following more economic way:

    <\code>
      square (n:Int): Int == n*n;
    </code>

    Programs would be more readable if you stuck to just one way.

    <\answer>
      <surround|The second way will be the most frequent one by far. However,
      one may think of situations where the second way of defining functions
      might be useful:||<\with>
        font shape
      <|with>
        right
      <|with>
        \;

        <\code>
          f: Int-\<gtr\>Int;

          ...

          f := (n:Int) :-\<gtr\> n+1;

          ...

          f := (n:Int) :-\<gtr\> n*n;
        </code>
      </with>>

      We might also choose for an other syntax, like <with|font
      shape|right|font family|tt|lambda (n:Int) do ...>
    </answer>

    <item>The convention with <with|font family|tt|left transitive>,
    <with|font family|tt|right transitive> functions (<with|font
    shape|slanted|converters?>), etc, is interesting, but I have no feeling
    for whether it's the right way to go - will it really work? Are there
    some examples you have in mind of how to use it?

    <\answer>
      Class inheritance is a typical example where transitive converters are
      useful. For instance, if we have an implicit converter from <with|font
      family|tt|font shape|right|Widget> to <with|font family|tt|font
      shape|right|Scheme_Expression>, and a derived class <with|font
      family|tt|font shape|right|Scrollable_Widget> from <with|font
      family|tt|font shape|right|Widget>, then we usually would like to have
      an implicit converter from <with|font family|tt|font
      shape|right|Widget> to <with|font family|tt|font
      shape|right|Scheme_Expression> as well.

      Conversily, although it may be handy to have an implicit converter from
      <with|font family|tt|font shape|right|Array(R)> to <with|font
      family|tt|font shape|right|Polynomial(R)>, we certainly do not want
      this converter to be transitive. Indeed, imagine that we have a
      converter from <with|font family|tt|font shape|right|Polynomial(R)> to
      <with|font family|tt|font shape|right|Scheme_Expression>. Then left
      composition with the converter from <with|font family|tt|font
      shape|right|Array(R)> to <with|font family|tt|font
      shape|right|Polynomial(R)> does not yield a desirable converter from
      <with|font family|tt|font shape|right|Array(R)> to <with|font
      family|tt|font shape|right|Scheme_Expression>.

      On the other hand, I am not sure whether we need the full generality of
      left and right transitive converters. Maybe just transitive converters
      will do.
    </answer>

    <item>The ``generators'' are sort of nice. You may want to think about
    assigning a meaning to something like <with|font family|tt|[1..4, 6..9]>.

    <\answer>
      <surround|Such a thing would correspond to a binary construct||<\with>
        font shape
      <|with>
        right
      <|with>
        \;

        <\code>
          ,: (Generator R, Generator R) -\<gtr\> Generator R
        </code>
      </with>>
    </answer>

    <item>What does <with|font family|tt|==\<gtr\>> do?

    <\answer>
      This construct is used for macro definitions. We might replace it by a
      <with|font family|tt|font shape|right|macro> keyword.
    </answer>

    <item>Why doesn't <with|font family|tt|nil> have a type, like <with|font
    family|tt|Nothing>? Then you could define <with|font
    family|tt|Potential(T)> to be <with|font family|tt|Union(T,Nothing)>,
    rather than letting it be a special construct.

    <\answer>
      That is because it only behaves as a union, but not really is a union.
      Indeed, in a real union type, it should be possible to determine the
      actual type of the union from other fields (or an implicit extra field)
      in the data structure. In the case of <with|font family|tt|font
      shape|right|Potential(T)>, we do not need any extra fields to determine
      the type.
    </answer>

    <surround|<item>||<code|Potential (T)>>

    ``<with|font shape|slanted|When compiling using the data safety option,
    an exception is raised whenever you attempt to cast <with|font
    family|tt|font shape|right|nil> to <with|font family|tt|font
    shape|right|T>.>''<vspace|0.5fn>

    The code usually has to check whether the pointer is nil before casting
    it, so why not take advantage of that by providing a conditional cast
    construction? It tests for non-nil, and in the then-clause, the variable
    of type <with|font family|tt|T> is available. Such code would be provably
    correct and fast even when the data safety option is off, so should be
    preferable.

    I guess my point is, that if you can discard a language construct that
    would cause an exception, you should. The fewer exceptions, the better.

    <\answer>
      First of all, I notice that one test for <with|font family|tt|font
      shape|right|nil> may correspond to different actions on the
      data-structure. Hence your strategy may indeed lead to useless tests.

      Furthermore, if you do not like the data safety option, you also should
      not like it in the case of <with|font family|tt|font shape|right|Array>
      and <with|font family|tt|font shape|right|Union>. But you probably do
      agree with me that systematic bound tests in the case of arrays may
      significantly slow down a program. One of the design goals of
      Mathemagix is that it should possibly be as fast as a language like C.

      Notice that we might also introduce <with|font family|tt|font
      shape|right|secure> and <with|font family|tt|font shape|right|insecure>
      modifiers to replace the data-safety option. This would allow the user
      to specify himself where speed and less security is needed.
    </answer>

    <item>``<with|font shape|slanted|Although intern exports make the
    signature less abstract, it is a very handy way to share natural common
    data.>''<vspace|0.5fn>

    But they aren't actually needed, why have them? The reasoning here seems
    weak, and it may come back to haunt you.

    <\answer>
      It is a very natural practice that data fields of classes may be
      inherited (look at C++ and java) and I found this extremely practical
      when writing TeXmacs. In Aldor, where such a facility is not provided,
      one has to rewrite all data access routines of the base class in any
      derived class which does not have the same representation type! Their
      focus on hiding ``implementation details'' thereby becomes a real pain
      for the programmer.

      Furthermore, I actually think that the importance of ``abstract black
      box classes with hidden implementations'' are very much overestimated
      by ``puritain programming language specialists''. I believe on the
      contrary that in many occasions knowing about certain implementation
      details of a class can be of a real help for a user of the class. It
      may for instance allow him to make more efficient use of it.
    </answer>

    <item>I like having classes available at run time. Maybe it should be
    possible to inspect them at runtime, and do things with the data in them,
    even though you don't know what they are in advance.

    <\answer>
      This should be possible as soon as a good semantics for variable extern
      exports has been invented.
    </answer>

    <item>About the hints: <with|font family|tt|persistant>, <with|font
    family|tt|commutative>, <with|font family|tt|clean>, <with|font
    family|tt|safe>; the compiler should not just accept such hints -- it
    should also prove the code to which the hint applies really has the
    property indicated. That would be very hard but very useful.

    Why do I demand this? Because the output from the program should not
    depend on the extent of compiler optimization. If a hint is false, but
    believed by the compiler, there will be really confusing bugs.

    <\answer>
      You are absolutely right and in the cases of the <with|font
      family|tt|font shape|right|persistant>, <with|font family|tt|font
      shape|right|clean> and <with|font family|tt|font shape|right|safe>
      modifiers this should indeed be possible. But for a modifier like
      <with|font family|tt|font shape|right|commutative> the compiler might
      have a harder job in order to prove this property...
    </answer>

    <item>Header <with|font family|tt|.gnh> files: I hate header files,
    because they require me to type the same information in two places -- it
    should be possible to have the compiler generate the required header
    files.

    <\answer>
      This is a quite controversal and difficult point. I see two main
      advantages in your philosophy:

      <\expand>
        enumerate-alpha
      <|expand>
        <item>It is more economic for the programmer.

        <item>It reduces the risk of error in copying (although this can be
        detected by the compiler).
      </expand>

      However, I also see the following disadvantages:

      <\expand>
        enumerate-alpha
      <|expand>
        <item>The header files have to be regenerated each time you change
        the source code (and potentially all other programs that depend on
        the header file, although the compiler might be clever enough to
        detect changes in the interface and the implementation).

        <item>The programmer is incited to put less effort in the design of a
        good interface to his software.

        <item>Automatically generated headers will tend to be of a lower
        quality than hand written interfaces. This makes it more difficult
        for a user to quickly learn about your software by browsing the
        header files.
      </expand>

      Do not forget that one of the design goals of Mathemagix is its fitness
      for large scale projects, like writing a computer algebra system with a
      lot of potential contributors. That is why I slightly prefered header
      files at a first glance. However, I agree that this issue should be
      discussed in greater detail.
    </answer>

    <item>Instantiation of classes at compile time: will this go as in C++?
    Maybe not, since we have the ability to create totally new classes at run
    time.

    <\answer>
      I do not understand the question very well; maybe I will answer you
      below.
    </answer>

    <item>The rule about types being constant when instantiated is there so
    the compiler can count on run-time type information remaining in one
    place while the instances are active. But, the rule could be abandoned:
    let the compiler create a new memory location to store the type and keep
    it there.

    <\answer>
      No. One very nice thing about Mathemagix is precisely that you do not
      have to keep the classes of instances in memory together with the
      instances themselves (although you may create an <with|font
      family|tt|font shape|right|Object> class with representation type
      <with|font family|tt|font shape|right|Record(T:$Class,x:T)>). This
      principle saves memory, increases the speed, but requires some
      programming discipline (which is again good in my opinion).
    </answer>

    <item>Another thing about the rule about types being constant when
    instantiated is this: what do you do when the type is stored on the
    stack, and the function whose scope it's in returns? The instance might
    survive (as a return value, for example), but the type information would
    go away! Or is that impossible for some reason having to do with the way
    the type of the function is specified?

    <\answer>
      <surround|I indeed cannot see how this might happen. The return class
      of a function might indeed be generic, but it is always determined in a
      precise way as a function of the classes of the arguments. For
      instance, when applying|in some piece of code, the return type
      <with|font family|tt|font shape|right|R> had to be passed to the
      function and was thereby already available in this piece of
      code.|<\with>
        font shape
      <|with>
        right
      <|with>
        \;

        <\code>
          generic_square: (R:$Ring, x:R) -\<gtr\> R
        </code>

        \;
      </with>>
    </answer>

    <item>In the section on exceptions:

    <\answer>
      Some dynamic type information seems to be necessary here, which
      conflicts with the spirit of the language.
    </answer>

    What spirit? Didn't I see classes being passed as parameters to
    functions? Isn't that ``dynamic type information''?

    <\answer>
      It depends what you mean by ``dynamic type information''. Indeed,
      classes may be passed to functions and the exports of these classes
      have to be stored somewhere. What I really meant is that it never
      occurs during execution time that an instance has to be checked to be
      of a particular class. In other words, the exact classes of all
      subexpressions of the source code are entirely known at compile time.
      One of the consequences of this very central and nice feature of
      Mathemagix is that no dynamic dispatching is needed at run time.
      Instead, classes are just big records of exported routines and we know
      at compile time which routine to call.
    </answer>

    <item>Are exceptions an essential feature of the language? The compiler
    would be simpler without them.

    One reason for having them is so error return values from system calls
    like <with|font family|tt|read()> and <with|font family|tt|write()> and
    <with|font family|tt|close()> can be handled (<with|font family|tt|disk
    full>, for example). But <with|font shape|italic|actually> handling these
    requires some skill; what can a program do when the disk is full? Why not
    die?

    <\answer>
      Exception handling is yet another of these very controversal issues and
      I do admit that I never used any of the exception handling facilities
      in C++ myself. Exceptions are a bit paradoxal because on the one hand,
      they reflect exceptional behaviour of a program (which are unforseen in
      its main specification), but on the other hand, the exceptional
      behaviour of a program needs to be part of its specification (if we
      want it to be correct under all circumstances).

      Another difficult issue about exceptions is that it may be hard for us
      to know what they will be used for in the future. This is particularly
      true in presence of parameterized classes. Indeed, it is hard for the
      conceptor of <with|font family|tt|font shape|right|Polynomial(R:$Ring)>
      to predict all possible exceptions which may be raised by some future
      ring.

      Let me finally mention the typical situation in which a tolerant form
      of exception handling may be useful. Imagine that a programmer
      conceives a program <with|font family|tt|font shape|right|Q> on top of
      a program <with|font family|tt|font shape|right|P> (where <with|font
      family|tt|font shape|right|P> was written by others, so that the
      programmer does not want to modify <with|font family|tt|font
      shape|right|P>). Now <with|font family|tt|font shape|right|Q> adds some
      new facilities to <with|font family|tt|font shape|right|P>, which may
      induce some exceptional behaviour. However, this exceptional behaviour
      was not foreseen in <with|font family|tt|font shape|right|P>, although
      <with|font family|tt|font shape|right|Q> might handle it.
    </answer>
  </enumerate>
</body>

<\initial>
  <\collection>
    <associate|preamble|false>
    <associate|odd page margin|30mm>
    <associate|paragraph width|150mm>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|paragraph hyphenation|professional>
    <associate|reduction page bottom margin|15mm>
    <associate|page type|a4>
    <associate|reduction page left margin|25mm>
    <associate|even page margin|30mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|cond-exports|4.5>
    <associate|rem-spec|6.1>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate>
      toc
    <|associate>
      <vspace*|1fn><with|font series|<quote|bold>|1 First comments by D.
      Grayson><htab|5mm>?<vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>
