
/******************************************************************************
* MODULE     : lazy_assign.cc
* DESCRIPTION: Lazy compilation of function types
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

generic make_lazy_cross (generic g);

class lazy_assign_rep: public lazy_rep {
public:
  lazy_assign_rep (context con, generic src, list subs);
  bool compile_this (bool force);
};

lazy_assign_rep::lazy_assign_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_assign_rep::compile_this (bool force) { (void) force;
  generic lval = get_value (subs[0]);
  generic ltype= get_type (subs[0]);
  if ((N (ltype) > 1) && (car (ltype) == TUPLE)) {
    fatal_error ("tuple assignments not yet implemented",
		 "lazy_assign_rep::compile_this",
		 "lazy_assign.cc");
  }
  else if (is_func (ltype, ALIAS_T, 1)) {
    generic rval= as_lazy (subs[1]) -> filter (ltype[1]);
    if (!nil (rval)) meaning (list (src[0], lval, rval), ltype[1]);
  }
  return TRUE;
}

generic
make_lazy_assign (generic g) {
  context con (as_context (g[0]), g);
  return lazy (new lazy_assign_rep (con, g[1], cdr (as_list (g[1]))));
}
