
/******************************************************************************
* MODULE     : lazy_begin.cc
* DESCRIPTION: Lazy compilation of statement blocks
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

class lazy_begin_rep: public lazy_rep {
public:
  lazy_begin_rep (context con, generic src, list subs);
  bool compile_this (bool force);
  void set_types_children ();
};

lazy_begin_rep::lazy_begin_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_begin_rep::compile_this (bool force) { (void) force;
  list    result= lhs (subs);
  generic type  = rhs (subs);
  if ((!nil (result)) && (!nil (type)))
    meaning (cons (car (src), result), type);
  return TRUE;
}

void
lazy_begin_rep::set_types_children () {
  if (!nil (subs)) as_lazy (subs [N(subs)-1]) -> set_type (req_type);
}

generic
make_lazy_begin (generic g) {
  context con= as_context (g[0]);
  return lazy (new lazy_begin_rep (con, g[1], cdr (as_list (g[1]))));
}
