
/******************************************************************************
* MODULE     : lazy_cross.cc
* DESCRIPTION: Lazy compilation of crosss
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

list make_lazy_cross_items (context con, list l);

class lazy_cross_rep: public lazy_rep {
public:
  lazy_cross_rep (context con, generic src, list subs);
  bool compile_this (bool force);
};

lazy_cross_rep::lazy_cross_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_cross_rep::compile_this (bool force) { (void) force;
  list result= lhs (subs);
  if (nil (subs) || (!nil (result))) {
    bool tuple_flag= (N(src)>=1) && (car (src) == TUPLE);
    if (tuple_flag) meaning (cons (car (src), result), con->get_void ());
    else meaning (car (result), con->get_void ());
  }
  return TRUE;
}

generic
make_lazy_cross (generic g) {
  context con (as_context (g[0]), g[1]);
  generic src= g[1];
  bool tuple_flag= (N(src)>=1) && (car(src) == TUPLE);
  list l= (tuple_flag ? cdr (as_list (src)): list (src));
  list r= make_lazy_cross_items (con, l);
  return lazy (new lazy_cross_rep (con, src, r));
}
