
/******************************************************************************
* MODULE     : lazy_declare.cc
* DESCRIPTION: Lazy compilation of declares
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

list make_lazy_declarations (context con, list l);

class lazy_declare_rep: public lazy_rep {
public:
  lazy_declare_rep (context con, generic src, list subs);
  bool compile_this (bool force);
};

lazy_declare_rep::lazy_declare_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_declare_rep::compile_this (bool force) { (void) force;
  list result= lhs (subs);
  if (!nil (result)) meaning (cons (car (src), result), con->get_void ());
  return TRUE;
}

generic
make_lazy_declare (generic g) {
  context con= as_context (g[0]);
  if (con->top_level) con->top_level= FALSE;
  else con= context (con, g[1]);
  list l= cdr (as_list (g[1]));
  list r= make_lazy_declarations (con, l);
  return lazy (new lazy_declare_rep (con, g[1], r));
}
