
/******************************************************************************
* MODULE     : lazy_error.cc
* DESCRIPTION: Lazy compilation of errors
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

class lazy_error_rep: public lazy_rep {
public:
  lazy_error_rep (context con, string message, generic where);
  bool compile_this (bool force);
};

lazy_error_rep::lazy_error_rep (context con, string message, generic where):
  lazy_rep (con, where)
{
  error (message, where);
}

bool
lazy_error_rep::compile_this (bool force) { (void) force;
  return TRUE;
}


generic
make_lazy_error (context con, string message, generic where) {
  return lazy (new lazy_error_rep (con, message, where));
}
