
/******************************************************************************
* MODULE     : lazy_foreign.cc
* DESCRIPTION: Lazy compilation of foreign material
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

class lazy_foreign_rep: public lazy_rep {
public:
  lazy_foreign_rep (context con, generic g);
  bool compile_this (bool force);
};

lazy_foreign_rep::lazy_foreign_rep (context con, generic g):
  lazy_rep (con, g) {}

bool
lazy_foreign_rep::compile_this (bool force) { (void) force;
  meaning (src, con->get_foreign ());
  return TRUE;
}

generic
make_lazy_foreign (generic g) {
  return lazy (new lazy_foreign_rep (as_context (g[0]), g[1]));
}
