
/******************************************************************************
* MODULE     : lazy_identifier.cc
* DESCRIPTION: Lazy compilation of identifiers
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

class lazy_identifier_rep: public lazy_rep {
public:
  lazy_identifier_rep (context con, generic g);
  bool compile_this (bool force);
};

lazy_identifier_rep::lazy_identifier_rep (context con, generic g):
  lazy_rep (con, g) {}

bool
lazy_identifier_rep::compile_this (bool force) { (void) force;
  list l= con->get_meanings (src);
  if (nil (l)) error ("undeclared identifier", src);
  else {
    list count= l;
    if (!force)
      while (!nil (count)) {
	if (gentype (S (car (count)) [1]) == LAZY_TYPE) {
	  cout << "type " << S (car (count)) [1] << " not yet compiled" << lf;
	  return FALSE;
	}
	count= cdr (count);
      }

    count= l;
    while (!nil (count)) {
      if (gentype (S (car (count)) [1]) != LAZY_TYPE)
	meaning (car (count), S (car (count)) [1]);
      count= cdr (count);
    }
  }
  return TRUE;
}

generic
make_lazy_identifier (generic g) {
  return lazy (new lazy_identifier_rep (as_context (g[0]), g[1]));
}
