
/******************************************************************************
* MODULE     : lazy_if.cc
* DESCRIPTION: Lazy compilation of statement blocks
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

class lazy_if_rep: public lazy_rep {
public:
  lazy_if_rep (context con, generic src, list subs);
  bool compile_this (bool force);
  void set_types_children ();
};

lazy_if_rep::lazy_if_rep (context con, generic g, list subs2):
  lazy_rep (con, g, subs2)
{
  // as_lazy (subs [0]) -> set_type (BOOL_T);
}

bool
lazy_if_rep::compile_this (bool force) { (void) force;
  generic cond_prg = get_value (subs[0]);
  generic then_prg = get_value (subs[1]);
  generic then_type= get_type  (subs[1]);
  if (N(subs) == 2) {
    if ((!nil (cond_prg)) && (!nil (then_prg)))
      meaning (list (car (src), cond_prg, then_prg), con->get_void ());
  }
  else {
    generic else_prg = get_value (subs[2]);
    generic else_type= get_type  (subs[2]);
    if ((!nil (cond_prg)) && (!nil (then_prg)) && (!nil (else_prg))) {
      if (then_type != else_type)
	error ("then and else part of different types", src);
      else meaning (list (car (src), cond_prg, then_prg, else_prg), then_type);
    }
  }
  return TRUE;
}

void
lazy_if_rep::set_types_children () {
  as_lazy (subs [1]) -> set_type (req_type);
  if (N(subs)>2) as_lazy (subs [2]) -> set_type (req_type);
}

generic
make_lazy_if (generic g) {
  context con= as_context (g[0]);
  return lazy (new lazy_if_rep (con, g[1], cdr (as_list (g[1]))));
}
