
/******************************************************************************
* MODULE     : lazy_into.cc
* DESCRIPTION: Lazy compilation of function types
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

generic make_lazy_cross (generic g);

class lazy_into_rep: public lazy_rep {
public:
  lazy_into_rep (context con, generic src, list subs);
  bool compile_this (bool force);
};

lazy_into_rep::lazy_into_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_into_rep::compile_this (bool force) { (void) force;
  generic l= get_value (subs[0]);
  generic r= get_value (subs[1]);
  meaning (list (src[0], l, r), con->get_void ());
  return TRUE;
}

generic
make_lazy_into (generic g) {
  context con (as_context (g[0]), g[1]);
  generic src= g[1];
  generic l  = make_lazy_cross (list (con, src[1]));
  generic r  = make_lazy_cross (list (con, src[2]));
  return lazy (new lazy_into_rep (con, src, list (l, r)));
}
