
/******************************************************************************
* MODULE     : lazy_lambda.cc
* DESCRIPTION: Lazy compilation of lambda expressions
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

list make_lazy_declarations (context con, list l);

class lazy_lambda_rep: public lazy_rep {
public:
  lazy_lambda_rep (context con, generic src, list subs);
  bool compile_this (bool force);
  void set_types_children ();
};

lazy_lambda_rep::lazy_lambda_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_lambda_rep::compile_this (bool force) { (void) force;
  list result= lhs (subs);
  if (!nil (result)) {
    generic tuple  = cons (car (src[1]), result (0, N(result) - 1));
    generic body   = result [N(result) - 1];
    generic lambda = list (car (src), tuple, body);
    generic bodyt  = rhs (subs);
    generic lambdat= list (INTO, tuple, bodyt);
    meaning (lambda, lambdat);
  }
  return TRUE;
}

void
lazy_lambda_rep::set_types_children () {
  if (nil (req_type)) return;
  lazy prg= as_lazy (req_type);
  if (!is_func (prg->src, INTO, 2)) return;
  generic dest= prg->subs [N(prg->subs)-1];
  if (!nil (subs)) as_lazy (subs [N(subs)-1]) -> set_type (dest);
}

generic
make_lazy_lambda (generic g) {
  context con (as_context (g[0]), g[1]);
  generic src= g[1];
  if (car (src[1]) != TUPLE)
    return make_lazy_error (con, "tuple expected", src[1]);
  list r= make_lazy_declarations (con, as_list (cdr (src[1])));
  return lazy (new lazy_lambda_rep (con, src, r * list (src[2])));
}
