
/******************************************************************************
* MODULE     : lazy_local.cc
* DESCRIPTION: Lazy compilation of locals
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

list make_lazy_locals (context con, list l);

class lazy_local_rep: public lazy_rep {
public:
  lazy_local_rep (context con, generic src, list subs);
  bool compile_this (bool force);
  void set_types_children ();
};

lazy_local_rep::lazy_local_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_local_rep::compile_this (bool force) { (void) force;
  list result= lhs (subs);
  if (!nil (result)) meaning (cons (car (src), result), rhs (subs));
  return TRUE;
}

void
lazy_local_rep::set_types_children () {
  if (!nil (subs)) as_lazy (subs [N(subs)-1]) -> set_type (req_type);
}

generic
make_lazy_local (generic g) {
  context con (as_context (g[0]), g);
  list l= cdr (as_list (g[1]));
  list r= make_lazy_locals (con, l);
  return lazy (new lazy_local_rep (con, g[1], r));
}
