
/******************************************************************************
* MODULE     : lazy_number.cc
* DESCRIPTION: Lazy compilation of numbers
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>
#include <mm_int.hh>

class lazy_number_rep: public lazy_rep {
public:
  lazy_number_rep (context con, generic g);
  bool compile_this (bool force);
};

lazy_number_rep::lazy_number_rep (context con, generic g):
  lazy_rep (con, g) {}

static generic
decode_int (string s) {
  bool minus= s[0]=='-';
  int i=(minus?0:1), n= N(s), r=0;
  for (i=0; i<n; i++)
    r= r*10 + ((int) (s[i]-'0'));
  return mm_int (minus?-r:r);
}

bool
lazy_number_rep::compile_this (bool force) { (void) force;
  string s= as_string (S (src));
  meaning (decode_int (s), con->get (INT_T)); // And floats ?
  return TRUE;
}

generic
make_lazy_number (generic g) {
  return lazy (new lazy_number_rep (as_context (g[0]), g[1]));
}
