
/******************************************************************************
* MODULE     : lazy_ref.cc
* DESCRIPTION: Lazy compilation of function types
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

generic make_lazy_cross (generic g);

class lazy_ref_rep: public lazy_rep {
public:
  lazy_ref_rep (context con, generic src, list subs);
  bool compile_this (bool force);
};

lazy_ref_rep::lazy_ref_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_ref_rep::compile_this (bool force) { (void) force;
  list l= as_lazy (subs[0])->meanings;
  while (!nil (l)) {
    generic item= car (l);
    meaning (list (src[0], item[0]), list (REF, item[1]));
    l= cdr (l);
  }
  return TRUE;
}

generic
make_lazy_ref (generic g) {
  context con (as_context (g[0]), g);
  generic src= g[1];
  generic arg= make_lazy (con, src[1]);
  return lazy (new lazy_ref_rep (con, src, list (arg)));
}
