
/******************************************************************************
* MODULE     : lazy_string.cc
* DESCRIPTION: Lazy compilation of strings
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

class lazy_string_rep: public lazy_rep {
public:
  lazy_string_rep (context con, generic g);
  bool compile_this (bool force);
};

lazy_string_rep::lazy_string_rep (context con, generic g):
  lazy_rep (con, g) {}

static string
decode_string (string s) {
  int i, n= N(s);
  string r;
  for (i=0; i<n; i++)
    if ((s[i]=='\\') && (i+1<n))
      switch (s[++i]) {
      case '\\': r << "\\"; break;
      case 'n': r << "\n"; break;
      case 't': r << "\t"; break;
      }
    else r << s[i];
  return r;
}

bool
lazy_string_rep::compile_this (bool force) { (void) force;
  string s= as_string (S (src));
  if ((N(s)>2) && (s[0]=='\042') && (s[N(s)-1]=='\042')) s= s(1,N(s)-1);
  s= decode_string (s);
  meaning (s, con->get (STRING_T));
  return TRUE;
}

generic
make_lazy_string (generic g) {
  return lazy (new lazy_string_rep (as_context (g[0]), g[1]));
}
