
/******************************************************************************
* MODULE     : lazy_tuple.cc
* DESCRIPTION: Lazy compilation of statement blocks
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

class lazy_tuple_rep: public lazy_rep {
public:
  lazy_tuple_rep (context con, generic src, list subs);
  bool compile_this (bool force);
};

lazy_tuple_rep::lazy_tuple_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_tuple_rep::compile_this (bool force) { (void) force;
  list result= lhs (subs);
  list types = rht (subs);
  if ((!nil (result)) && (!nil (types)))
    meaning (cons (car (src), result), cons (TUPLE, types));
  return TRUE;
}

generic
make_lazy_tuple (generic g) {
  context con= as_context (g[0]);
  return lazy (new lazy_tuple_rep (con, g[1], cdr (as_list (g[1]))));
}
