
/******************************************************************************
* MODULE     : lazy_typemod.cc
* DESCRIPTION: Lazy compilation of type inheritance
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

class lazy_typemod_rep: public lazy_rep {
public:
  lazy_typemod_rep (context con, generic src, list subs);
  bool compile_this (bool force);
};

lazy_typemod_rep::lazy_typemod_rep (context con, generic g, list subs):
  lazy_rep (con, g, subs) {}

bool
lazy_typemod_rep::compile_this (bool force) { (void) force;
  generic type= get_value (subs[0]);
  meaning (list (src[0], type), con->get_signature ());
  return TRUE;
}

generic
make_lazy_typemod (generic g) {
  context con (as_context (g[0]), g);
  generic src = g[1];
  generic type= make_lazy (con, src[1]);
  return lazy (new lazy_typemod_rep (con, src, list (type)));
}
