
/******************************************************************************
* MODULE     : test1.cc
* DESCRIPTION: Test compiler
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <file.hh>
#include <mm_parser.hh>
#include <compiler.hh>
#include <error.hh>

char line[]= "-------------------------------------------------------------\n";

string
input () {
  int i;
  char in[1000];
  cout << "in ] ";
  for (i=0; i<999; i++) {
    cin.get(in[i]);
    if (in[i]=='\n') break;
  }
  in[i]='\0';
  return in;
}

void
compile_string (context& con, string s) {
  list errors;
  generic g= mm_parse (s, errors);
  generic v= compile (con, g, errors);
  cout << line;
  if (N(errors)!=0) {
    print_errors (errors);
    cout << line;
  }
  cout << pritty << v << normal << "\n";
  cout << line;
}

int
main (int argc, char** argv) {
  int i;
  string s;

  context con;
  string preamble;
  (void) load ("$MMX_PATH/mmx/basic.mm", preamble);
  cout << "Compiling preamble\n";
  cout << line;
  compile_string (con, preamble);
  DEBUG_COMPILATION= DEBUG_INSTRUCTIONS + DEBUG_DECLARATIONS;

  for (i=1; i<argc; i++) {
    cout << "Compiling " << argv[i] << "\n";
    cout << line;
    if (load (argv[i], s)) {
      cout << "Couldn't open file\n";
      cout << line;
    }
    else compile_string (con, s);
  }

  if (argc == 1)
    while (TRUE) {
      s= input ();
      if (s == "") break;
      insert_source (s, "cmdline");
      cout << line;
      compile_string (con, s);
    }

  return 0;
}
