
/******************************************************************************
* MODULE     : coerce.cc
* DESCRIPTION: Routines for type conversions
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>
#include <function.hh>
#include <error.hh>

void
lazy_rep::dereference () {
  list meanings1= meanings;
  list meanings2;
  while (!nil (meanings1)) {
    generic item= car (meanings1);
    meanings2= cons (item, meanings2);
    if ((N(item[1]) == 2) && (item[1][0] == ALIAS_T)) {
      generic type= item[1][1];
      list count= meanings;
      bool ok= TRUE;
      while (!nil (count)) {
	if (car (count) [1] == type) { ok= FALSE; break; }
	count= cdr (count);
      }
      if (ok) {
	generic item2= list (list (DEREF, item[0]), type);
	meanings2= cons (item2, meanings2);
      }
    }
    meanings1= cdr (meanings1);
  }
  meanings= meanings2;
}

void
dereference (list& l) {
  if (nil (l)) return;
  as_lazy (car (l)) -> dereference ();
  dereference (cdr (l));
}

static generic
filter_search (generic type, list l) {
  if (nil (l)) return generic ();
  generic g= car (l);
  if (g[1] == type) return g[0];
  return filter_search (type, cdr (l));
}

generic
lazy_rep::filter (generic type) {
  generic value= filter_search (type, meanings);
  if (nil (value)) {
    dereference ();
    value= filter_search (type, meanings);
    if (nil (value)) error ("type mismatch", src);
  }
  return value;
}
