
/******************************************************************************
* MODULE     : compiler.cc
* DESCRIPTION: the heart of the mathemagix compiler
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <compiler.hh>
#include <lazy.hh>

/******************************************************************************
* Main compilation routine
******************************************************************************/

generic
compile (context& con, generic g, list& errors) {
  initialize_lazy ();
  if (nil (con)) con= context (con, g);
  else con->scope= g;
  con->top_level= TRUE;
  lazy prg= as_lazy (make_lazy (con, g));
  while (prg->compile (FALSE)) {
    if (DEBUG_COMPILATION & DEBUG_INSTRUCTIONS)
      cout << "--------------------------------------------------------" << lf;
  }
  if (DEBUG_COMPILATION & DEBUG_INSTRUCTIONS)
    cout << "--------------------------------------------------------" << lf;
  prg->compile (TRUE);
  errors  = errors * prg->errors;
  return prg->meanings;
}
