
/******************************************************************************
* MODULE     : test1.cc
* DESCRIPTION: Test interpreter
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <list.hh>
#include <symbol.hh>
#include <file.hh>
#include <interpreter.hh>

int
main (int argc, char** argv) {
  int i;
  string s;

  string preamble;
  (void) load ("$MMX_PATH/mmx/basic.mm", preamble);
  if (run (preamble)) exit (1);

  for (i=1; i<argc; i++) {
    if (load (argv[i], s)) cout << "Couldn't open file " << argv[i] << "\n";
    else if (run (s)) exit (1);
  }

  if (run (list (symbol ("main")))) exit (1);
  return 0;
}
