
/******************************************************************************
* MODULE     : mm_ostream.hh
* DESCRIPTION: mathemagix output streams
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MM_OSTREAM_HH
#define __MM_OSTREAM_HH
#include <string.hh>
#include <list.hh>

class mm_ostream;
class mm_ostream_rep: generic_rep {
public:
  generic  name; // a descriptive name
  ostream& out;  // the ostream

protected:
  int Type ();
  int Hash ();
  bool Equal (generic g);
  generic Copy ();
  int Arity ();
  void Print (ostream& out);

public:
  inline mm_ostream_rep (generic name2, ostream& out2):
    name (name2), out (out2) {}

  friend class mm_ostream;
  friend mm_ostream copy (mm_ostream t);
  friend ostream& operator << (ostream& out, mm_ostream a);
};

class mm_ostream {
protected:
  mm_ostream_rep* rep;
  inline mm_ostream (mm_ostream_rep* rep2): rep (rep2) {}

public:
  inline mm_ostream (generic name, ostream& out):
    rep (new mm_ostream_rep (name, out)) {}
  inline friend mm_ostream as_mm_ostream (generic g) {
    if (gentype(g) != MM_OSTREAM_TYPE)
      fatal_error ("generic is not an mm_ostream",
		   "as_mm_ostream", "mm_ostream.hh");
    return mm_ostream ((mm_ostream_rep*) g.rep); }
  inline operator generic () { return generic (rep); }
  inline mm_ostream_rep* operator -> () { return rep; }

  inline bool operator == (mm_ostream out) {
    return ((&rep->out) == (&out->out)); }
  inline bool operator != (mm_ostream out) {
    return ((&rep->out) != (&out->out)); }
  friend mm_ostream copy (mm_ostream a);
  friend ostream& operator << (ostream& out, mm_ostream a);

  friend class mm_ostream_rep;
};

#endif // __MM_OSTREAM_HH
