
/******************************************************************************
* MODULE     : mirror.cc
* DESCRIPTION: Fixed size mirrors. Zero characters can be part of mirror.
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <mirror.hh>

/******************************************************************************
* Required functions for generic structures
******************************************************************************/

int
mirror_rep::Type () {
  return MIRROR_TYPE;
}

void
mirror_rep::Print (ostream& out) {
  out << mirror (this);
}

/******************************************************************************
* Constructors and convertors for mirrors
******************************************************************************/

inline
mirror_rep::mirror_rep (generic g): generic_rep (), ref (g) {
  if (!nil (g)) {
    begin= g->begin;
    end  = g->end  ;
  }
}

ostream&
operator << (ostream& out, mirror m) {
  if (N(m->ref)!=3) {
    out << "#mirror";
    print_entries (out, m->ref);
  }
  else out << "$" << m->ref[0];
  return out;
}
