
/******************************************************************************
* MODULE     : mirror.hh
* DESCRIPTION: for creating different distinct mirrors of a given generic
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MIRROR_HH
#define __MIRROR_HH
#include <string.hh>
#include <table.hh>

class mirror;
class mirror_rep: generic_rep {
protected:
  generic ref;

  int Type ();
  void Print (ostream& out);

public:
  mirror_rep (generic g);

  friend class mirror;
  friend generic& S (mirror m);
  friend ostream& operator << (ostream& out, mirror m);
};

class mirror {
protected:
  mirror_rep* rep;
  inline mirror (mirror_rep* rep2): rep (rep2) {}

public:
  inline mirror (generic g): rep (new mirror_rep (g)) {}
  inline friend mirror as_mirror (generic g) {
    if (gentype(g) != MIRROR_TYPE)
      fatal_error ("generic is not a mirror", "as_mirror", "mirror.hh");
    return mirror ((mirror_rep*) g.rep); }
  inline operator generic () { return generic (rep); }
  inline mirror_rep* operator -> () { return rep; }

  inline friend generic& S (mirror m) { return m->ref; }
  friend ostream& operator << (ostream& out, mirror m);

  friend class mirror_rep;
};

#endif // __MIRROR_HH
